<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <title>Task 32.50</title>
</head>

<body>
    <div class="container">
        <div class="text-center">
            <h2>Danh sách người dùng đăng ký</h2>
        </div>
        <table class="table table-bordered table-striped table-hover" id="tbl-user">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody></tbody>
        </table>
    </div>
</body>
<script>
    "use strict";
    $(document).ready(function () {
        onPageLoading();
    });
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $("#tbl-user").on("click", ".btn-edit", onBtnEditClick);
    $("#tbl-user").on("click", ".btn-delete", onBtnDeleteClick);
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        callApiDataUser();
    }
    function onBtnEditClick() {
        console.log("Edit user Id: " + $(this).data("id"));
    }
    function onBtnDeleteClick() {
        console.log("Delete user Id: " + $(this).data("id"));
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm load data dùng ajax
    function callApiDataUser() {
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/",
            type: "GET",
            success: function (paramUser) {
                console.log(paramUser);
                loadDataToTable(paramUser);
            },
            error: function (paramError) {
                console.log(paramError.status);
            }
        });
    }
    //hàm load data vào table
    function loadDataToTable(paramUser) {
        for (var bI = 0; bI < paramUser.length; bI++) {
            // tạo row
            var bNewRow = $("<tr>").appendTo("#tbl-user tbody");
            //tạo cột
            $("<td>").html(paramUser[bI].id).appendTo(bNewRow);
            $("<td>").html(paramUser[bI].firstname).appendTo(bNewRow);
            $("<td>").html(paramUser[bI].lastname).appendTo(bNewRow);
            $("<td>").html(paramUser[bI].country).appendTo(bNewRow);
            $("<td>").html(paramUser[bI].subject).appendTo(bNewRow);
            $("<td>").html(paramUser[bI].customerType).appendTo(bNewRow);
            $("<td>").html(paramUser[bI].registerStatus).appendTo(bNewRow);
            //tạo cột chứa button edit + delete
            var bColAction = $("<td>").appendTo(bNewRow);
            //tạo button edit
            var bBtnEdit = $("<button>")
                .attr("class", "btn btn-primary col-6 btn-edit")
                .html("Sửa");
            bBtnEdit.attr("data-id", paramUser[bI].id);
            bBtnEdit.attr("data-firstname", paramUser[bI].firstname);
            bBtnEdit.attr("data-lastname", paramUser[bI].lastname);
            bBtnEdit.attr("data-country", paramUser[bI].country);
            bBtnEdit.attr("data-subject", paramUser[bI].subject);
            bBtnEdit.attr("data-customerType", paramUser[bI].customerType);
            bBtnEdit.attr("data-registerStatus", paramUser[bI].registerStatus);
            //add vào cột
            bBtnEdit.appendTo(bColAction);
            //tạo button delete
            var bBtnDelete = $("<button>")
                .attr("class", "btn btn-danger col-6 btn-delete")
                .html("Xoá");
            bBtnDelete.attr("data-id", paramUser[bI].id);
            bBtnDelete.attr("data-firstname", paramUser[bI].firstname);
            bBtnDelete.attr("data-lastname", paramUser[bI].lastname);
            bBtnDelete.attr("data-country", paramUser[bI].country);
            bBtnDelete.attr("data-subject", paramUser[bI].subject);
            bBtnDelete.attr("data-customerType", paramUser[bI].customerType);
            bBtnDelete.attr("data-registerStatus", paramUser[bI].registerStatus);
            //add vào cột
            bBtnDelete.appendTo(bColAction);
        }
    }
</script>

</html>